/* initialization and debugging info gets written from here */
int write_log(int options, char *description) {
	errno =0;
	int status;
	time_t now;
	char *datebuf;
	now = time(NULL);
	datebuf = ctime(&now);
	datebuf[strlen(datebuf)-1]= '\0';

	/*send termination signals to monitor and master */
	if(options & OCTOPUS_LOG_EXIT) {
		if(group != NULL) {
			if((group->foreground == FOREGROUND_INIT) || (group->foreground == FOREGROUND_ON)) {
				fprintf(stderr, "%s\n", description);
			}
			/*write to syslog */
			if(group->use_syslog == 1) {
				openlog("octopus", LOG_PID, LOG_DAEMON);
				syslog(LOG_ALERT, "%s",description);
				closelog();
			}	 
			/*write to the logfile if it has been initialized */
			if( group->log_file != NULL) {
				fprintf(group->log_file, "%s - %s\n", datebuf, description);
				fflush(group->log_file);
			}
			if(group->monitor_pid > 0) {
				kill(group->monitor_pid, SIGTERM);
			}
			waitpid(group->monitor_pid, &status, 0);
			if(group->master_pid > 0) {
				kill(group->master_pid, SIGTERM);
			}
			waitpid(group->master_pid, &status, 0);
			exit(-1);
		}
		else {
			fprintf(stderr, "%s\n", description);
			exit(-1);
		}
	}

	/*write to normal log here */
	if(group != NULL) {
		/*write to syslog */
		if((options & OCTOPUS_LOG_SYSLOG) && (group->use_syslog == 1)) {
			openlog("octopus", LOG_PID, LOG_DAEMON);
			syslog(LOG_ALERT, "%s",description);
			closelog();
		}	 
		if( group->log_file == 0) {
			fprintf(stderr, "%s\n", description);
		}
		else {
			if (group->foreground == FOREGROUND_ON) {
				fprintf(stderr, "%s\n", description);
			}
			else if(group->log_file != NULL) {
				fprintf(group->log_file, "%s - %s\n", datebuf, description);
				fflush(group->log_file);
			}
		}
	}
	else {
		fprintf(stderr, "%s\n", description);
	}
	return 0;	
	
}
